package com.emoon.knowledge.service.impl;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.emoon.common.core.utils.MapstructUtils;
import com.emoon.common.core.utils.StringUtils;
import com.emoon.common.mybatis.core.page.PageQuery;
import com.emoon.common.mybatis.core.page.TableDataInfo;
import com.emoon.knowledge.domain.ThinkAgent;
import com.emoon.knowledge.domain.bo.ThinkAgentBo;
import com.emoon.knowledge.domain.vo.ThinkAgentVo;
import com.emoon.knowledge.mapper.ThinkAgentMapper;
import com.emoon.knowledge.service.IThinkAgentService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;


import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author wangkang
 * @date 2025-11-26
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ThinkAgentServiceImpl implements IThinkAgentService {

    private final ThinkAgentMapper baseMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 主键
     * @return 【请填写功能名称】
     */
    @Override
    public ThinkAgentVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询【请填写功能名称】列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 【请填写功能名称】分页列表
     */
    @Override
    public TableDataInfo<ThinkAgentVo> queryPageList(ThinkAgentBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ThinkAgent> lqw = buildQueryWrapper(bo);
        Page<ThinkAgentVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的【请填写功能名称】列表
     *
     * @param bo 查询条件
     * @return 【请填写功能名称】列表
     */
    @Override
    public List<ThinkAgentVo> queryList(ThinkAgentBo bo) {
        LambdaQueryWrapper<ThinkAgent> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ThinkAgent> buildQueryWrapper(ThinkAgentBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ThinkAgent> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ThinkAgent::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getAgent()), ThinkAgent::getAgent, bo.getAgent());
        lqw.eq(StringUtils.isNotBlank(bo.getIntroduce()), ThinkAgent::getIntroduce, bo.getIntroduce());
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ThinkAgentBo bo) {
        ThinkAgent add = MapstructUtils.convert(bo, ThinkAgent.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ThinkAgentBo bo) {
        ThinkAgent update = MapstructUtils.convert(bo, ThinkAgent.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ThinkAgent entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除【请填写功能名称】信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
